import { ParseTreeListener } from 'antlr4ts/tree/ParseTreeListener';
import { ProgramContext } from './RPScriptParser';
import { SourceElementsContext } from './RPScriptParser';
import { StatementContext } from './RPScriptParser';
import { StatementListContext } from './RPScriptParser';
import { PipeActionsContext } from './RPScriptParser';
import { SingleActionContext } from './RPScriptParser';
import { CommentContext } from './RPScriptParser';
import { ActionContext } from './RPScriptParser';
import { ParamListContext } from './RPScriptParser';
import { ParamContext } from './RPScriptParser';
import { OptListContext } from './RPScriptParser';
import { OptContext } from './RPScriptParser';
import { SingleExpressionContext } from './RPScriptParser';
import { ShortFnContext } from './RPScriptParser';
import { VariableContext } from './RPScriptParser';
import { VarFunctionContext } from './RPScriptParser';
import { VarParamsContext } from './RPScriptParser';
import { LiteralContext } from './RPScriptParser';
import { SymbolContext } from './RPScriptParser';
import { OptNameContext } from './RPScriptParser';
import { ObjectLiteralContext } from './RPScriptParser';
import { ArrayLiteralContext } from './RPScriptParser';
import { ElementListContext } from './RPScriptParser';
import { PropertyAssignmentContext } from './RPScriptParser';
import { PropertyNameContext } from './RPScriptParser';
import { EosContext } from './RPScriptParser';
/**
 * This interface defines a complete listener for a parse tree produced by
 * `RPScriptParser`.
 */
export interface RPScriptListener extends ParseTreeListener {
    /**
     * Enter a parse tree produced by `RPScriptParser.program`.
     * @param ctx the parse tree
     */
    enterProgram?: (ctx: ProgramContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.program`.
     * @param ctx the parse tree
     */
    exitProgram?: (ctx: ProgramContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.sourceElements`.
     * @param ctx the parse tree
     */
    enterSourceElements?: (ctx: SourceElementsContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.sourceElements`.
     * @param ctx the parse tree
     */
    exitSourceElements?: (ctx: SourceElementsContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.statement`.
     * @param ctx the parse tree
     */
    enterStatement?: (ctx: StatementContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.statement`.
     * @param ctx the parse tree
     */
    exitStatement?: (ctx: StatementContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.statementList`.
     * @param ctx the parse tree
     */
    enterStatementList?: (ctx: StatementListContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.statementList`.
     * @param ctx the parse tree
     */
    exitStatementList?: (ctx: StatementListContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.pipeActions`.
     * @param ctx the parse tree
     */
    enterPipeActions?: (ctx: PipeActionsContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.pipeActions`.
     * @param ctx the parse tree
     */
    exitPipeActions?: (ctx: PipeActionsContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.singleAction`.
     * @param ctx the parse tree
     */
    enterSingleAction?: (ctx: SingleActionContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.singleAction`.
     * @param ctx the parse tree
     */
    exitSingleAction?: (ctx: SingleActionContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.comment`.
     * @param ctx the parse tree
     */
    enterComment?: (ctx: CommentContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.comment`.
     * @param ctx the parse tree
     */
    exitComment?: (ctx: CommentContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.action`.
     * @param ctx the parse tree
     */
    enterAction?: (ctx: ActionContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.action`.
     * @param ctx the parse tree
     */
    exitAction?: (ctx: ActionContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.paramList`.
     * @param ctx the parse tree
     */
    enterParamList?: (ctx: ParamListContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.paramList`.
     * @param ctx the parse tree
     */
    exitParamList?: (ctx: ParamListContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.param`.
     * @param ctx the parse tree
     */
    enterParam?: (ctx: ParamContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.param`.
     * @param ctx the parse tree
     */
    exitParam?: (ctx: ParamContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.optList`.
     * @param ctx the parse tree
     */
    enterOptList?: (ctx: OptListContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.optList`.
     * @param ctx the parse tree
     */
    exitOptList?: (ctx: OptListContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.opt`.
     * @param ctx the parse tree
     */
    enterOpt?: (ctx: OptContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.opt`.
     * @param ctx the parse tree
     */
    exitOpt?: (ctx: OptContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.singleExpression`.
     * @param ctx the parse tree
     */
    enterSingleExpression?: (ctx: SingleExpressionContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.singleExpression`.
     * @param ctx the parse tree
     */
    exitSingleExpression?: (ctx: SingleExpressionContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.shortFn`.
     * @param ctx the parse tree
     */
    enterShortFn?: (ctx: ShortFnContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.shortFn`.
     * @param ctx the parse tree
     */
    exitShortFn?: (ctx: ShortFnContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.variable`.
     * @param ctx the parse tree
     */
    enterVariable?: (ctx: VariableContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.variable`.
     * @param ctx the parse tree
     */
    exitVariable?: (ctx: VariableContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.varFunction`.
     * @param ctx the parse tree
     */
    enterVarFunction?: (ctx: VarFunctionContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.varFunction`.
     * @param ctx the parse tree
     */
    exitVarFunction?: (ctx: VarFunctionContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.varParams`.
     * @param ctx the parse tree
     */
    enterVarParams?: (ctx: VarParamsContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.varParams`.
     * @param ctx the parse tree
     */
    exitVarParams?: (ctx: VarParamsContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.literal`.
     * @param ctx the parse tree
     */
    enterLiteral?: (ctx: LiteralContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.literal`.
     * @param ctx the parse tree
     */
    exitLiteral?: (ctx: LiteralContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.symbol`.
     * @param ctx the parse tree
     */
    enterSymbol?: (ctx: SymbolContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.symbol`.
     * @param ctx the parse tree
     */
    exitSymbol?: (ctx: SymbolContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.optName`.
     * @param ctx the parse tree
     */
    enterOptName?: (ctx: OptNameContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.optName`.
     * @param ctx the parse tree
     */
    exitOptName?: (ctx: OptNameContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.objectLiteral`.
     * @param ctx the parse tree
     */
    enterObjectLiteral?: (ctx: ObjectLiteralContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.objectLiteral`.
     * @param ctx the parse tree
     */
    exitObjectLiteral?: (ctx: ObjectLiteralContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.arrayLiteral`.
     * @param ctx the parse tree
     */
    enterArrayLiteral?: (ctx: ArrayLiteralContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.arrayLiteral`.
     * @param ctx the parse tree
     */
    exitArrayLiteral?: (ctx: ArrayLiteralContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.elementList`.
     * @param ctx the parse tree
     */
    enterElementList?: (ctx: ElementListContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.elementList`.
     * @param ctx the parse tree
     */
    exitElementList?: (ctx: ElementListContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.propertyAssignment`.
     * @param ctx the parse tree
     */
    enterPropertyAssignment?: (ctx: PropertyAssignmentContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.propertyAssignment`.
     * @param ctx the parse tree
     */
    exitPropertyAssignment?: (ctx: PropertyAssignmentContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.propertyName`.
     * @param ctx the parse tree
     */
    enterPropertyName?: (ctx: PropertyNameContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.propertyName`.
     * @param ctx the parse tree
     */
    exitPropertyName?: (ctx: PropertyNameContext) => void;
    /**
     * Enter a parse tree produced by `RPScriptParser.eos`.
     * @param ctx the parse tree
     */
    enterEos?: (ctx: EosContext) => void;
    /**
     * Exit a parse tree produced by `RPScriptParser.eos`.
     * @param ctx the parse tree
     */
    exitEos?: (ctx: EosContext) => void;
}
