import { ATN } from 'antlr4ts/atn/ATN';
import { Parser } from 'antlr4ts/Parser';
import { ParserRuleContext } from 'antlr4ts/ParserRuleContext';
import { TerminalNode } from 'antlr4ts/tree/TerminalNode';
import { TokenStream } from 'antlr4ts/TokenStream';
import { Vocabulary } from 'antlr4ts/Vocabulary';
import { RPScriptListener } from './RPScriptListener';
export declare class RPScriptParser extends Parser {
    static readonly T__0: number;
    static readonly T__1: number;
    static readonly T__2: number;
    static readonly T__3: number;
    static readonly T__4: number;
    static readonly T__5: number;
    static readonly T__6: number;
    static readonly T__7: number;
    static readonly T__8: number;
    static readonly T__9: number;
    static readonly T__10: number;
    static readonly DIRECTIVE: number;
    static readonly PIPE: number;
    static readonly EnvVarLiteral: number;
    static readonly VAR: number;
    static readonly FUNCTION: number;
    static readonly COMMENT: number;
    static readonly NullLiteral: number;
    static readonly BooleanLiteral: number;
    static readonly DecimalLiteral: number;
    static readonly StringLiteral: number;
    static readonly TemplateStringLiteral: number;
    static readonly SYMBOL: number;
    static readonly WORD: number;
    static readonly NL: number;
    static readonly WS: number;
    static readonly RULE_program: number;
    static readonly RULE_sourceElements: number;
    static readonly RULE_statement: number;
    static readonly RULE_statementList: number;
    static readonly RULE_pipeActions: number;
    static readonly RULE_singleAction: number;
    static readonly RULE_comment: number;
    static readonly RULE_action: number;
    static readonly RULE_paramList: number;
    static readonly RULE_param: number;
    static readonly RULE_optList: number;
    static readonly RULE_opt: number;
    static readonly RULE_singleExpression: number;
    static readonly RULE_shortFn: number;
    static readonly RULE_variable: number;
    static readonly RULE_varFunction: number;
    static readonly RULE_varParams: number;
    static readonly RULE_literal: number;
    static readonly RULE_symbol: number;
    static readonly RULE_optName: number;
    static readonly RULE_objectLiteral: number;
    static readonly RULE_arrayLiteral: number;
    static readonly RULE_elementList: number;
    static readonly RULE_propertyAssignment: number;
    static readonly RULE_propertyName: number;
    static readonly RULE_eos: number;
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    readonly vocabulary: Vocabulary;
    readonly grammarFileName: string;
    readonly ruleNames: string[];
    readonly serializedATN: string;
    constructor(input: TokenStream);
    program(): ProgramContext;
    sourceElements(): SourceElementsContext;
    statement(): StatementContext;
    statementList(): StatementListContext;
    pipeActions(): PipeActionsContext;
    singleAction(): SingleActionContext;
    comment(): CommentContext;
    action(): ActionContext;
    paramList(): ParamListContext;
    param(): ParamContext;
    optList(): OptListContext;
    opt(): OptContext;
    singleExpression(): SingleExpressionContext;
    shortFn(): ShortFnContext;
    variable(): VariableContext;
    varFunction(): VarFunctionContext;
    varParams(): VarParamsContext;
    literal(): LiteralContext;
    symbol(): SymbolContext;
    optName(): OptNameContext;
    objectLiteral(): ObjectLiteralContext;
    arrayLiteral(): ArrayLiteralContext;
    elementList(): ElementListContext;
    propertyAssignment(): PropertyAssignmentContext;
    propertyName(): PropertyNameContext;
    eos(): EosContext;
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static readonly _ATN: ATN;
}
export declare class ProgramContext extends ParserRuleContext {
    EOF(): TerminalNode;
    sourceElements(): SourceElementsContext | undefined;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class SourceElementsContext extends ParserRuleContext {
    statement(): StatementContext[];
    statement(i: number): StatementContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class StatementContext extends ParserRuleContext {
    pipeActions(): PipeActionsContext | undefined;
    singleAction(): SingleActionContext | undefined;
    comment(): CommentContext | undefined;
    NL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class StatementListContext extends ParserRuleContext {
    statement(): StatementContext[];
    statement(i: number): StatementContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class PipeActionsContext extends ParserRuleContext {
    action(): ActionContext[];
    action(i: number): ActionContext;
    PIPE(): TerminalNode;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class SingleActionContext extends ParserRuleContext {
    action(): ActionContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class CommentContext extends ParserRuleContext {
    COMMENT(): TerminalNode;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class ActionContext extends ParserRuleContext {
    WORD(): TerminalNode;
    paramList(): ParamListContext;
    optList(): OptListContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class ParamListContext extends ParserRuleContext {
    param(): ParamContext[];
    param(i: number): ParamContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class ParamContext extends ParserRuleContext {
    singleExpression(): SingleExpressionContext | undefined;
    symbol(): SymbolContext | undefined;
    action(): ActionContext | undefined;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class OptListContext extends ParserRuleContext {
    opt(): OptContext[];
    opt(i: number): OptContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class OptContext extends ParserRuleContext {
    optName(): OptNameContext;
    literal(): LiteralContext | undefined;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class SingleExpressionContext extends ParserRuleContext {
    literal(): LiteralContext | undefined;
    shortFn(): ShortFnContext | undefined;
    arrayLiteral(): ArrayLiteralContext | undefined;
    variable(): VariableContext | undefined;
    action(): ActionContext | undefined;
    objectLiteral(): ObjectLiteralContext | undefined;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class ShortFnContext extends ParserRuleContext {
    action(): ActionContext;
    variable(): VariableContext[];
    variable(i: number): VariableContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class VariableContext extends ParserRuleContext {
    VAR(): TerminalNode;
    varParams(): VarParamsContext[];
    varParams(i: number): VarParamsContext;
    varFunction(): VarFunctionContext[];
    varFunction(i: number): VarFunctionContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class VarFunctionContext extends ParserRuleContext {
    FUNCTION(): TerminalNode;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class VarParamsContext extends ParserRuleContext {
    singleExpression(): SingleExpressionContext[];
    singleExpression(i: number): SingleExpressionContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class LiteralContext extends ParserRuleContext {
    NullLiteral(): TerminalNode | undefined;
    BooleanLiteral(): TerminalNode | undefined;
    StringLiteral(): TerminalNode | undefined;
    TemplateStringLiteral(): TerminalNode | undefined;
    DecimalLiteral(): TerminalNode | undefined;
    EnvVarLiteral(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class SymbolContext extends ParserRuleContext {
    SYMBOL(): TerminalNode;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class OptNameContext extends ParserRuleContext {
    WORD(): TerminalNode;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class ObjectLiteralContext extends ParserRuleContext {
    propertyAssignment(): PropertyAssignmentContext[];
    propertyAssignment(i: number): PropertyAssignmentContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class ArrayLiteralContext extends ParserRuleContext {
    elementList(): ElementListContext | undefined;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class ElementListContext extends ParserRuleContext {
    singleExpression(): SingleExpressionContext[];
    singleExpression(i: number): SingleExpressionContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class PropertyAssignmentContext extends ParserRuleContext {
    propertyName(): PropertyNameContext;
    singleExpression(): SingleExpressionContext;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class PropertyNameContext extends ParserRuleContext {
    StringLiteral(): TerminalNode | undefined;
    DecimalLiteral(): TerminalNode | undefined;
    WORD(): TerminalNode | undefined;
    SYMBOL(): TerminalNode | undefined;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
export declare class EosContext extends ParserRuleContext {
    EOF(): TerminalNode;
    constructor(parent: ParserRuleContext, invokingState: number);
    readonly ruleIndex: number;
    enterRule(listener: RPScriptListener): void;
    exitRule(listener: RPScriptListener): void;
}
