/// <reference types="node" />
import ConfigStore from 'configstore';
import { RpsContext, RpsModuleModel } from 'rpscript-interface';
import { KeywordsMgr } from './keywordsmgr';
import { EventEmitter } from 'events';
export declare class ModuleMgr {
    readonly CONFIG_NAME: string;
    readonly NPM_MOD_PREFIX: string;
    readonly NPM_MOD_ORG_PREFIX: string;
    static readonly MOD_INSTALLED_NPM_EVT: string;
    static readonly MOD_INSTALLED_CONFIG_EVT: string;
    static readonly MOD_INSTALLED_ERROR_EVT: string;
    static readonly MOD_REMOVED_NPM_EVT: string;
    static readonly MOD_REMOVED_CONFIG_EVT: string;
    static readonly MOD_REMOVED_ERROR_EVT: string;
    static readonly MOD_LOADED_EVT: string;
    static readonly MOD_DISABLED_EVT: string;
    static readonly MOD_LOAD_ERROR_EVT: string;
    configStore: ConfigStore;
    wordMgr: KeywordsMgr;
    event: EventEmitter;
    constructor();
    installModule(npmModuleName: string, allowExtModule?: boolean): Promise<RpsModuleModel>;
    private installFromNpm(npmModuleName);
    removeModule(moduleName: string): Promise<void>;
    private removeModuleConfig(npmModuleName);
    listModuleNames(): string[];
    listInstalledModules(): Object;
    listAvailableModules(): Object;
    loadModuleObjs(rpsContext: RpsContext, modules?: string[]): Promise<Object>;
    private genDefaultApi(modObj, rpsContext);
    private getModuleNpmName(moduleName);
}
