"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const shelljs_1 = __importDefault(require("shelljs"));
const HOMEDIR = require('os').homedir();
class NpmModHelper {
    static installNpmModule(moduleName) {
        let child = shelljs_1.default.exec(`npm install --save --prefix ${HOMEDIR}/.rpscript/modules ${moduleName}`, { silent: true });
        if (!child.stdout && child.stderr)
            throw new Error('' + child.stderr);
        let result = '' + child.stdout;
        let version = result.substring(result.lastIndexOf('@') + 1, result.indexOf('\n')).trim();
        let mod = result.substring(result.indexOf('+') + 1, result.lastIndexOf('@')).trim();
        return {
            version: version,
            moduleName: mod,
            text: child.stdout
        };
    }
    static removeNpmModule(moduleName) {
        let child = shelljs_1.default.exec(`npm remove --save --prefix ${HOMEDIR}/.rpscript/modules ${moduleName}`, { silent: true });
        if (!child.stdout && child.stderr)
            throw new Error('' + child.stderr);
        return child.stdout;
    }
}
exports.NpmModHelper = NpmModHelper;
